        /* Copyright (c) 2007 by IBM Corporation */
        
dojo.provide("zero.form.common.components.BaseWrapper");

dojo.require("zero.form.common.components.UidMixin");
dojo.require('dijit._Widget');
dojo.require("zero.form.common.components.WidgetFactory");

dojo.declare("zero.form.common.components.BaseWrapper", 
				[dijit._Widget, zero.form.common.components.UidMixin], {
 
        internalWidgetType:"",
        internalWidgetId:"",
		disabled: false,
		connects: null,
		wrapperContainer: null,
		widgetFactory: null,
		
        addElement: function(creationParams)
        {
			this.internalWidgetId = "_".concat(this.getUid());
			if(creationParams === null  ||  creationParams === undefined)
			{
				creationParams = {};
			}
			creationParams['id'] = this.internalWidgetId;
			var type = this.getTypeOfWidget(creationParams.type);
			this.widget = this.getWidgetFactory().createWidget(type,creationParams);
			this.widget.startup();
			this.setProperties();
			this.setWidgetConnections();
            this.containerNode.appendChild(this.widget.domNode);
            this.internalWidgetType = type;
        },     

		getWidget: function()
		{
			return this.widget;
		},

		getWidgetFactory: function()
		{
			return this.widgetFactory || (this.widgetFactory = new zero.form.common.components.WidgetFactory());	
		},
        
        getType: function()
        {
			return this.internalWidgetType;
        },
        
        postMixInProperties: function()
        {
           	this.inherited("postMixInProperties", arguments);
     		this.connects = [];
			this.id = this.getUid();
        },
		
		setWrapperContainer: function(wrapperContainer)
		{
			if(this.wrapperContainer === wrapperContainer)
				return;
			for(var i=0, l = this.connects.length;i<l;i++)
			{
				dojo.disconnect(this.connects[i]);
			}
			this.connects = [];
			this.wrapperContainer && this.wrapperContainer.decreaseWrapperCount();
			this.wrapperContainer = wrapperContainer;
			this.wrapperContainer.increaseWrapperCount();
			this.connects.push(dojo.connect(this, 'onRemovePressed', wrapperContainer, 'removePressed'));
            this.connects.push(dojo.connect(this, 'onRemoveFinished', wrapperContainer, 'removeFinished'));

		},
		
        setDisabled: function(isDisabled)
        {
			this.disabled = isDisabled;
			this.getWidget().setDisabled(isDisabled);
        },
		
        removePressed: function(evt)
        {
			if(this.disabled)
				return;
            this.onRemovePressed(this);
			this.mainContainer.style.display = 'none';
            this.finishRemove();
            this.destroyRecursive();
			this.onRemoveFinished(this);
        },

        finishRemove: function(){}, // to be overide upon inheritance
	    onRemovePressed: function(wrapper){},//callback, occurs when the user presses the remove field icon
	    onRemoveFinished: function(wrapper){}, // callback - after the removal process ended
 		setProperties: function(){},
		setWidgetConnections: function(){},
		
		getTypeOfWidget: function(unMappedType){}
		
});
