        /* Copyright (c) 2007 by IBM Corporation */
        
dojo.provide("zero.form.common.components.DndWrapperContainer");

dojo.require("zero.form.common.components.BaseWrapperContainer");
dojo.require("dojo.dnd.Source");
dojo.require("dojox.uuid.generateRandomUuid");

dojo.declare("zero.form.common.components.DndWrapperContainer", null,{

		dndRoot: null,
		createdWrapper: null,
		markedElement: null,
		isDndWrapperContainer: true,
		
		dndNodeCreator: function(data, hint)
		{
			if(hint == 'avatar')
			{
				data.pUid = dojox.uuid.generateRandomUuid();
			}
			if (typeof data == "string")
			{
				var creatingElement = dijit.byId(data);
				data = {};
				data.type = creatingElement.type;
				data.title = creatingElement.getTitle();
				data.creationParams = {};
				data.creationParams.creator = creatingElement;
			}
			var possibleWrapper = dijit.byId(data.pUid);
			if(possibleWrapper)
			{
				return {node: possibleWrapper.domNode, data: data, type: [ZERO_FORM_DND_ELEMENT]};
			}
			var wrapper = this.instantiateWrapper(data);
			data.creationParams = data.creationParams || {}
			data.creationParams.hint = hint;
			this.wireWrapper(wrapper, data.creationParams);
			this.createdWrapper = wrapper;
			if(hint === 'avatar')
			{
				this.decreaseWrapperCount();
			}
			if(hint !== 'avatar')
			{
				this.onSuccessfullCreation(wrapper);
			}			
			return {node: wrapper.domNode, data: data, type: [ZERO_FORM_DND_ELEMENT]};
		},

		overSource: function(source)
		{
			source && source.parent && console.debug(dijit.getEnclosingWidget(source.parent).id);
		},

		getDndRoot: function()
		{
			if(!this.dndRoot)
			{
				
				var slf = this;
				this.dndRoot = new zero.form.common.components.NestableSource(this.containerNode, 
							{	accept: [ZERO_FORM_DND_ELEMENT], 
								creator: dojo.hitch(this,"dndNodeCreator"), 
								withHandles: true
							});

				dojo.subscribe("/dnd/drop", dojo.hitch(this, "wrapperDropped"));
			}
			return this.dndRoot;
		},
		
		wrapperDropped: function(source,nodes,iscopy)
		{
			var wrapper = dijit.byId(nodes[0].id.substring(3));
			if(source == this.dndRoot)
			{
				this.handleWrapperDropped(wrapper);
				//this.onFinishedDnd();
				
			}
			else
				wrapper && wrapper.setWrapperContainer(this);
		},


/*	    createElement: function(type, creationParams) 
        {
			var wrapper = this.createWrapper(type,creationParams);
			this.wireWrapper(wrapper, creationParams);
			this.onSuccessfullCreation(wrapper);
			wrapper.startup();
            return wrapper;         
	    },*/

		
		createElement: function(creationParams)
		{
			creationParams = creationParams || {};
			creationParams.creationType = creationParams.creationType || "click"; // remains clone if it was clone
			this.getDndRoot().insertNodes(false,
					[{	type:creationParams.type,
						title:creationParams.title,
						sibling:creationParams.sibling,
						pUid:creationParams.pUid,
						creationParams:creationParams
					}],creationParams && creationParams.isBefore, creationParams.sibling && creationParams.sibling.domNode);
			var wrapper = this.createdWrapper;
			this.createdWrapper = null;
			wrapper.startup();
			return wrapper;
		},
		
		getDndReferenceNode: function(before)
		{
			var allChildren = this.containerNode.getElementsByTagName("tr");
			if(before)
			{
				return allChildren[0];
			}
			//var lastChild = allChildren[allChildren.length-1];
		//	var enclosingWrapper = dijit.getEnclosingWidget(lastChild);
		//	if(enclosingWrapper.declaredClass ==="freedom.widget.ide.environment.MessageWrapper")
		//	{
	//			if(allChildren.length ===1)
	//				return lastChild;
	//			return allChildren[allChildren.length-2];
	//		}
		},
		
		handleWrapperDropped: function(wrapper){}
	
});


dojo.declare("zero.form.common.components.NestableSource",dojo.dnd.Source,{
	
		markedNode: null,
		
		onMouseMove: function(e)
		{
				if(this.isInMouseMove)
					return;
				this.isInMouseMove = true;
				this.inherited("onMouseMove", arguments);
				this.isInMouseMove = false;
		},
		
		onDndDrop: function()
		{
			var parentWidget = dijit.getEnclosingWidget(this.parent);
			var t = dojo.dnd.manager().target;
			var targetWidget = dijit.getEnclosingWidget(t.node);
			if(targetWidget !== parentWidget)
			{
				this.current = t.node;
				this.onDndCancel();
			}
			else
			{
				this.inherited("onDndDrop", arguments);
				targetWidget.onFinishedDnd && targetWidget.onFinishedDnd(true);
			}		
		},
		
		_addItemClass : function(node, type)
		{
			if(node !== this.targetAnchor)
				return this.inherited("_addItemClass",arguments);
			if(this.markedNode)
			{
				return;
			}
			this.markedNode = node;
			var w= dijit.getEnclosingWidget(node);
			if(w && w.isDndWrapperContainer)
			{
				w = dijit.getEnclosingWidget(w.getDndReferenceNode(this.before));
			}
			/*if(w && w.declaredClass ==="freedom.widget.ide.environment.MessageWrapper")
			{
				w=w.infoNode;
				type = "Before";
			}*/
			dojo.addClass((w && w.mainContainer)  || node, "dojoDndItem" + type);
		},	
	
		_removeItemClass: function(node, type)
		{
			if(node !== this.targetAnchor)
				return this.inherited("_removeItemClass",arguments);
			this.markedNode = null;
			var w= dijit.getEnclosingWidget(node);
			/*if(w && w.declaredClass ==="freedom.widget.ide.environment.MessageWrapper")
			{
				w=w.infoNode;
				type = "Before";
			}*/
			dojo.removeClass((w && w.mainContainer) || node, "dojoDndItem" + type);
		},
		
		_legalMouseDown: function(e){
			// summary: checks if user clicked on "approved" items
			// e: Event: mouse event
			if(!this.withHandles){ return true; }
			for(var node = e.target; node && !dojo.hasClass(node, "dojoDndItem"); node = node.parentNode){
				if(dojo.hasClass(node, "notDojoDndHandle")){ return false; }
				if(dojo.hasClass(node, "dojoDndHandle")){ return true; }
			}
			return false;	// Boolean
		},

		onMouseOver: function(e)
		{
			e.cancelBubble = true;
			this.inherited("onMouseOver", arguments);
			var w = dijit.getEnclosingWidget(this.current);
			if(w && w.isDndWrapperContainer)
			{
				this.current = wrappingWidget.getDndReferenceNode(this.before);
			}
		}		
});
