/* Copyright (c) 2007 by IBM Corporation */

dojo.provide("zero.form.widget.field.BaseFieldValidationMixin");
dojo.require("zero.form.widget.field.FormFieldBaseMixin");

dojo.declare(
    "zero.form.widget.field.BaseFieldValidationMixin", 
    zero.form.widget.field.FormFieldBaseMixin,
    {
        invalidContentMessage: "",
        invalidMessage:"",
        requiredMessage: "",
        invalidClass: "zeroFormInvalid",
        isValueOK: true,          
		baseClass: "zeroForm-base-mixin-css",
		
        postCreate: function()
		{
			this.inherited("postCreate",arguments);
			this.supportedEvents.push("onValid");
			this.supportedEvents.push("onInvalid");
		},
		
        validate: function()
        {
        	this.setErrorMessage(null);
        	
            if(this.disabled)
			{
				this.setErrorMessage(null);				
				return;
			}

            if(this.isMissing())
            {
                this.invalidMessage = this.requiredMessage || (this.requiredMessage = this.getString("REQUIRED_MESSAGE"));
            }
            else
            {
                var isContentValid = this.isContentValid() && this.isValid();
                if(!isContentValid)
                {
                    this.invalidMessage = this.invalidContentMessage || (this.invalidContentMessage = this.getString("INVALID_ENTERED_VALUE"));
                } 
                else
                {
                    this.invalidMessage = null;
                }
            }
            this.setErrorMessage(this.invalidMessage);
        },
        
        isMissing: function()
        {
            return (this.required  && (this.getValue() === null || this.getValue() === undefined || this.getValue() === ""));
        },
        
        isContentValid: function(){return true}, // subclasses may override this function to provide non-regExp based validation
        
        
        isValidValue: function() 
        {
            return this.isValueOK;
        },
        
        setErrorMessage: function(errorMsg, forceUpdate)
        {
			if(!errorMsg)
            {
                if(this.invalidSpan.style.display !== "none") // no error message in a state that an error message was displayed previously
				{
	                this.invalidSpan.style.display = "none";
	                this.isValueOK = true;
					this.onValid();					
				}
            }
            else
            {
                if(this.invalidSpan.style.display  === "" && forceUpdate)// error message already exists and we need to update it
				{
					this.invalidSpan.innerHTML = this.getString("INVALID_MESSAGE_DISPLAY",{singleSpace:"&nbsp;",message:errorMsg});
				}
				if(this.invalidSpan.style.display !== "" ) // an error message exists in a state that a previous error message was not displayed
				{
					this.invalidSpan.innerHTML = this.getString("INVALID_MESSAGE_DISPLAY",{singleSpace:"&nbsp;",message:errorMsg});
                	this.invalidSpan.style.display = "block";
                	this.isValueOK = false;
					this.onInvalid(); 					
				}
				
            }
        },

        select: function() 
        {
            this.textbox.select();
        },

        setDisabled: function(isDisabled)
        {
            this.disabled = isDisabled;
			this.textbox.disabled  = isDisabled;
			this.setErrorMessage(null);
        },
		
		onValid: function(){},
		onInvalid: function(){}
});
