                                      /* Copyright (c) 2007 by IBM Corporation */

dojo.provide("zero.form.widget.field.CheckboxField");

dojo.require("dijit.form.CheckBox");
dojo.require("zero.form.widget.field.FormFieldBaseMixin");

dojo.declare(
    "zero.form.widget.field.CheckboxField",
    [dijit.form.CheckBox, zero.form.widget.field.FormFieldBaseMixin],
    {
        _showHideTitleSeparately: false,

		startup: function()
		{
			zero.form.widget.field.CheckboxField.superclass.startup.apply(this, arguments);
			dojo.connect(this.focusNode,"onmouseover",this,"onMouseOver");
			dojo.connect(this.focusNode,"onclick",this,"onClick");
			dojo.connect(this.focusNode,"onmouseout",this,"onMouseOut");
			dojo.connect(this.focusNode,"onclick",this,"onChange");
			
			if (!((undefined == this.defaultValue) || (null == this.defaultValue)))
				this.setValue(this.defaultValue);
		}	,

        setValue: function(isChecked)
        {
            if (typeof(isChecked) == 'boolean')
            {
                this.setChecked(isChecked);
            }
            else
            {
                this.setChecked(isChecked == "on" || isChecked == "true");
            }
        },

		getValue: function()
		{
			return this.checked;
		},

        validate: function()
        {
            return true;  // The value of this widget is always valid
        },

        isValidValue: function()
        {
            return true;  // The value of this widget is always valid
        },

		disable: function()
		{
			zero.form.widget.field.CheckboxField.superclass.disable.apply(this, arguments);
			this.inputNode.disabled = true;
		},

		enable: function()
		{
			zero.form.widget.field.CheckboxField.superclass.enable.apply(this, arguments);
			this.inputNode.disabled = false;
		},

		onClick: function(e)
		{
			zero.form.widget.field.CheckboxField.superclass.onClick.apply(this, arguments);
			this.onChange();
		}
    }
);
