        /* Copyright (c) 2007 by IBM Corporation */
        
dojo.provide("zero.form.widget.field.ComboBoxField");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("zero.form.widget.field.BaseFieldValidationMixin");
//dojo.require("zero.form.widget.field.DataStores");

dojo.declare(
    "zero.form.widget.field.ComboBoxField", 
    [dijit._Widget,dijit._Templated, 
	zero.form.widget.field.BaseFieldValidationMixin], 
    {
        templateString: null,
        templatePath: dojo.moduleUrl("zero","form/widget/field/templates/combo-box-field.html"),
		options: null,
        
		startup: function()
		{
			zero.form.widget.field.ComboBoxField.superclass.startup.apply(this, arguments);
			this.initOptions();
		},

		initOptions: function()
		{
			if ((undefined !== this.options) && (null !== this.options))
			{
				this.setUserDefinedOptions(this.options);
			}
		},
				
		setAdditionalProperties: function(pJson)
		{
			zero.form.widget.field.ComboBoxField.superclass.setAdditionalProperties.apply(this, arguments);
			if (pJson.options !== undefined)
			{
				this.setOptions(pJson.options);
			}
		},
		
		getAdditionalProperties: function(pJson)
		{
			zero.form.widget.field.ComboBoxField.superclass.getAdditionalProperties.apply(this, arguments);
			if (this.options !== undefined && this.options !== null)
			{
				pJson.options = this.options;
			}
		},

		setOptions: function(pOptions)
		{
			this.options = pOptions;
			this.initOptions();
		},
		
		getOptions: function()
		{
			return this.options;
		},

		setUserDefinedOptions: function(options)
		{
			this.comboNode.options.length = 0;
			if(options && options.length) // an array
			{
				for(var i=0; i<options.length;i++)
				{
					this.comboNode.options[i] = new Option(options[i].opt, options[i].val);	
				}
			}
		}, 
		
 		setDisabled: function(toDisable)
		{
			this.comboNode.disabled = toDisable;
		},
        
		getValue: function()
		{
			return this.getSelectedOption();
		},
		
		setValue: function(newValue)
        {
			var index = this.getIndexOfOptionWithText(newValue);
			if (index >= 0) 
			{
				this.comboNode.selectedIndex = index;
			}
			this.onChange();
			this.validate();
        },
		
		getSelectedOption: function()
		{
			if(this.comboNode.selectedIndex < 0)
			{
				return null;
			}	
			return this.comboNode.options[this.comboNode.selectedIndex].value || this.comboNode.options[this.comboNode.selectedIndex].text;	
		},
		
		getIndexOfOptionWithText: function(value)
		{
			for(var i=0;i<this.comboNode.options.length;i++)
			{
				if(this.comboNode.options[i].value === value || this.comboNode.options[i].text == value )
				{
					return i;	
				}					
			}
			return -1;				
		},
		
		isValid: function()
		{
			return true;
		},
        
        onfocus: function()
        {
            zero.form.widget.field.ComboBoxField.superclass.onfocus.apply(this, arguments);
            dojo.addClass(this.textbox, "zeroFormTextInFocus");
        },
        
        onblur: function()
        {
            zero.form.widget.field.ComboBoxField.superclass.onblur.apply(this, arguments);
			dojo.removeClass(this.textbox, "zeroFormTextInFocus");
            this.validate();                        
        },
        
        onkeyup: function()
        {
            zero.form.widget.field.ComboBoxField.superclass.onkeyup.apply(this, arguments);
            this.validate();                        
        },
        
        onkeypress: function()
        {
            zero.form.widget.field.ComboBoxField.superclass.onkeypress.apply(this, arguments);
            this.validate();                        
        },
         
		onChange: function(){}
    }
);
