/* Copyright (c) 2007 by IBM Corporation */

dojo.provide("zero.form.widget.field.TextFieldValidationMixin");

dojo.require("dijit._Templated");
dojo.require("zero.form.widget.field.BaseFieldValidationMixin");

dojo.declare(
    "zero.form.widget.field.TextFieldValidationMixin", 
    zero.form.widget.field.BaseFieldValidationMixin,
    {
        templateString:null,
	    templatePath: dojo.moduleUrl("zero","form/widget/field/templates/text-field-validation-mixin.html"),
	  	alreadyFocused : false,
		inSetValue: false,
		 invalidClass: "zeroFormInvalid",
		
		
        setValue: function(newValue,isValid) 
        {
			if(this.inSetValue)
				return;
			this.inSetValue = true;
			this.textbox.value = newValue;
            this.validate();
			if(isValid === undefined) // HACK : dojo calls the setValue method from _onBlur with the isValid param (thus we don't need to call onChange here)
			{
				this.onChange();
			}
			this.inSetValue = false;
        },
        
        getValue: function() 
        {
            return this.textbox.value;
        },
 	  
        onkeyup: function(e)
		{
			this.validate();
			this.handleOnKeyUp();
			this.onChange();
		},
        
		handleOnKeyUp: function()
		{
		},
		
        startup: function()
        {
            this.inherited("startup", arguments); 
            this.regExp = this.buildRegExp() || this.regExp;
        },
        
        buildRegExp: function()
        {
        	return null;
        },

        onfocus: function(/*Event*/ e)
        {      
            if(this.alreadyFocused)
				return;
			else
				this.alreadyFocused = true;
			dojo.addClass(this.textbox, "FieldTextInFocus");
        },
        
        onblur: function(/*Event*/ e)
        {
			this.alreadyFocused = true;
			dojo.removeClass(this.textbox, "FieldTextInFocus");
        }
});
