/* Copyright (c) 2007 by IBM Corporation */

dojo.provide("zero.form.widget.field.properties.RangePropertyHandlerMixin");
dojo.require("zero.form.widget.field.properties.PropertyHandler");
dojo.declare(
    "zero.form.widget.field.properties.RangePropertyHandlerMixin", 
	zero.form.widget.field.properties.PropertyHandler,
    {
		update: function()
		{
			if (!this.widget.constraints) 
			{
				this.widget.constraints = {};
			}
			this.setMax(this._getWidgetMax());
			this.setMin(this._getWidgetMin());
			this.widget.validate();
		},
					
		_getWidgetMax: function()
		{
			return this.widget.maxValue;
		},
		
		_getWidgetMin: function()
		{
			return this.widget.minValue;
		},

		setMax: function(newMax)
		{
			if (newMax === undefined || newMax === null || newMax === "") 
			{
				delete this.widget.constraints.max;
			}
			else 
			{
				this.widget.constraints.max = newMax;
			}
		},
		
		setMin: function(newMin)
		{
			if (newMin === undefined || newMin === null || newMin === "") 
			{
				delete this.widget.constraints.min;
			}
			else 
			{
				this.widget.constraints.min = newMin;
			}
        }
    }
);
